/*
 *
 * @(#)WebSafeHuePalette.java 2.0 00/05/13
 *
 * Copyright (c) 2000 Ginger Booth.  All Rights Reserved.
 *
 * @author Ginger Booth
 * @version 2.0, 00/05/13
 *
 * The 216 web-safe colors in order by hue, as Palettable. It's pretty silly
 * to make this thing a courseware Palette, since we not only don't want those
 * behaviors, but do want some new ones. So let's do Palettable interface, and
 * allow mix&match diff kinds of palettes.
 */


package com.gingerbooth.websafe;
import courseware.util.Palettable;
import java.awt.Color;
import java.util.*;

public class WebSafeHuePalette implements Palettable {
  // Colors are stored when they're asked for the first time.
  static private Color[] colors = new Color[WebSafeHue.hues.length];
  static private Vector extraColors = new Vector(1,1); // there may be gaps in this Vector....

  public Color getColor(int i) {
    if (colors[i] == null) {
      int[] rgb = WebSafeHue.hues[i];
      colors[i] = new Color(rgb[0], rgb[1], rgb[2]);
    }
    return colors[i];
  }

  public int getNumColors() {
    return WebSafeHue.hues.length + extraColors.size();
  }
  public void setColor(int i, Color c) {
    if (i < 0)
      return;

    if (i < WebSafeHue.hues.length) {
      colors[i] = c;
      return;
    }

    i -= WebSafeHue.hues.length;
    if (i < extraColors.size()) {
      extraColors.setElementAt(c, i);
      return;
    }
    extraColors.ensureCapacity(i+1);
    extraColors.setElementAt(c, i+1);
  }
}
