package courseware.jfcdep;

import javax.swing.JFrame;
import java.awt.*;
import courseware.util.*;
import courseware.jfcdep.*;

/**
 * Title:        Courseware
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Yale Inst. Biospheric Studies
 * @author Ginger Booth
 * @version 1.0
 *
 * Trying to localize all Swing-specific code into courseware, so no
 * changes needed to modules.... Trickier than it might have been...
 */

public class CWFrame extends JFrame {
  boolean created = false;
  public CWFrame(String title) {
    super(title);
    created = true;
  }

  public CWFrame() {
    super();
    created = true;
  }

  public void setLayout(LayoutManager lm) {
    if (!created) {
      super.setLayout(lm);
    } else {
      Container cp = getContentPane();
      if (cp == null)
        System.err.println("can't setLayout, content pane is null");
      else
        getContentPane().setLayout(lm);
    }
  }

  public Component add(Component c) {
    if (!created)
      return super.add(c);
    else
      return getContentPane().add(c);
  }
  public Component add(String name, Component comp) {
    if (!created)
      return super.add(name, comp);
    else
      return getContentPane().add(name, comp);
  }
  public Component add(Component comp, int index) {
    if (!created)
      return super.add(comp,index);
    else
      return getContentPane().add(comp,index);
  }
  public void add(Component comp, Object constraints) {
    if (!created)
      super.add(comp,constraints);
    else
      getContentPane().add(comp,constraints);
  }
  public void add(Component comp, Object constraints, int index) {
    if (!created)
      super.add(comp,constraints,index);
    else
      getContentPane().add(comp,constraints,index);
  }



}