package courseware.jfcdep;

import javax.swing.JCheckBox;

/**
 * Title:        Courseware
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Yale Inst. Biospheric Studies
 * @author Ginger Booth
 * @version 1.0
 */
import java.awt.*;
import javax.swing.plaf.basic.*;
import javax.swing.*;
import java.net.*;

public class ClearCheckBox extends JCheckBox {
  public static String onFilename = "images/checkon.gif";
  public static String offFilename = "images/checkoff.gif";
  private static ImageIcon onIcon;
  private static ImageIcon offIcon;

  public ClearCheckBox(String label, boolean value) {
    super(label, value);
    setForeground(CWGlobals.foreground);
    setBackground(CWGlobals.background);
    this.setEnabled(true);
    if (CWGlobals.applet != null){
      try {
        URL docbase = CWGlobals.applet.getDocumentBase();
        onIcon = new ImageIcon(new URL(docbase, onFilename));
        offIcon = new ImageIcon(new URL(docbase, offFilename));
      } catch (Exception e) {
        System.err.println("new checkbox failed: " + e);
        Thread.dumpStack();
        return;
      }
    } else {
        try {
          onIcon = new ImageIcon(onFilename);
          offIcon = new ImageIcon(offFilename);
        } catch (Exception e) {
          System.err.println("new checkbox failed: " + e);
          Thread.dumpStack();
          return;
        }
      }
      this.setIcon(offIcon);
      this.setSelectedIcon(onIcon);
      this.setOpaque(true);
  }
  public void paint(Graphics g) {
    CWGlobals.drawBackground(g, this);
    // vfb, 010118
    // why, yes, this is nuts... However, if you set opaque false,
    // paint isn't called on clicks. Yet if set opaque true, it
    // draws the background, overruling my background. So must set
    // opaque true to get control, false to draw only the icon....
    this.setOpaque(false);
    super.paint(g);
    this.setOpaque(true);
  }
}