/*
 * 
 * @(#)FnOfX.java 0.2 980515
 *
 * Copyright (c) 1997 Ginger Booth.  All Rights Reserved.
 * 
 * @history: original
 * @author Ginger Booth
 * @version 0.1, August 1997
 *          0.2, September 1998 supercedes PlottableFn, which is now a
 *               common superset of FnOfX and GenerableFn
 */
package courseware.plot;

/** Note that it doesn't really matter whether your data is
 *  inherently double.  Just pretend, if it's not.  As it happens,
 *  Plot calls this from min to max with a given stepsize, 
 *  never out of order.  Hence, feel free to use memory of the 
 *  previous value and set the step size accordingly on PlotFn.addTrace().
 */
public interface FnOfX extends PlottableFn {
    /** The stepsize can be ignored, unless there are discontinuities
     *  in the function. If so, fOfX must use stepsize to make sure any
     *  x less than stepsize away from a discontinuity, is placed
     *  directly on it, to return NaN or +-infinity there. xOfX allows
     *  the function to adjust the x value to its liking. Important when
     *  mixing discrete and continuous functions on same plot, or with
     *  parameterized functions (where f(x) and x are both functions of
     *  something else, although this doesn't solve > 1 f(x) per x-value.)
     */
    public double fOfX(double x, double stepsize);
    public double xOfX(double x, double stepsize);
}

