/*
 *
 * @(#)Marker.java 000922
 *
 * Copyright (c) 2000 Ginger Booth.  All Rights Reserved.
 * Author:       Ginger Booth, ginger@gingerbooth.com
 * Company:      Yale IBS/CCE
 * Description:  Plot traces + markers (points)
 *
 * Created 000922, vfb, for eco.diversity labs.
 */


package courseware.plot;
import java.awt.Color;

public class Marker {
  double x, y;
  Color color;
  int pixSize = 4;
  int style = 2;
  public static final int CIRCLE = 0;
  public static final int SQUARE = 1;
  public static final int FCIRCLE = 2;
  public static final int FSQUARE = 3;

  public Marker(double x, double y, Color c, int pixSize, int style) {
    this.x = x;
    this.y = y;
    this.color = c;
    this.pixSize = pixSize;
    this.style = style;
  }
  /** default marker is 4-pixel filled circle */
  public Marker(double x, double y, Color c) {
    this.x = x;
    this.y = y;
    this.color = c;
  }
  public void setXY(double x, double y) {this.x = x; this.y = y;}
  public void setDraw(Color c, int pixSize, int style) {
    this.color = c;
    this.pixSize = pixSize;
    this.style = style;
  }

}