/*
 *
 * @(#)GraphUtil.java 0.2 98/05/23
 *
 * Copyright (c) 1998 Ginger Booth.  All Rights Reserved.
 * @history: original
 * @author Ginger Booth
 * @version 0.2, May 1998
 */
package courseware.util;

/** A place to put stuff like thick lines.  No data, just static
 *  utilities.  No clipping performed unless explicitly stated here.
 *  Clip for the whole drawing, not one line of it....
 */
import java.awt.*;

public class GraphUtil {
    /** Simply draws two lines, the first as specified, and the
     *  second one pixel higher or to the right, depending on
     *  which delta is greater.
     */
    static public void doubleLine(Graphics g,
                       int x0, int y0, int x1, int y1) {
        // the number 3.5 is purely arbitrary
        if ((3.5 * Math.abs(x1 - x0)) > Math.abs(y1 - y0)) {
           g.drawLine(x0, y0, x1, y1);
           g.drawLine(x0, y0-1, x1, y1-1);
        } else {
           g.drawLine(x0, y0, x1, y1);
           g.drawLine(x0+1, y0, x1+1, y1);
        }
    }
    /** Call doubleLine for each segment of a polygon */
    static public void doublePolygon(Graphics g,
                       int[] x, int[] y, int npts) {
        for (int i=0; i<npts-1; i++)
            doubleLine(g, x[i], y[i], x[i+1], y[i+1]);
    }

}
