/*
 *
 * @(#)HomeLogoButton.java 0.2 98/12/16
 *
 * Copyright (c) 1998 Ginger Booth.  All Rights Reserved.
 *
 * @history: original
 * @author Ginger Booth
 * @version 0.2, December 1998
 */
package courseware.util;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import courseware.jfcdep.*;


public class HomeLogoButton extends BufferCanvas {
/** A HomeLogoButton has a picture on it. It acts like a ReaderButton. If the file to read
 *  is non-null, it spawns an external reader on that URL. This is for putting
 *  a link to site home on a CourseWare module. The "logoURL" should be JPG or GIF,
 *  although some other file formats may work on some platforms.
 *  If no go-to-URL action is desired, send a null newpageURL to constructor.
 */
  public String gotoURL;
  public String imageURL;
  public Applet owner;
  public Image logoImage;

  public HomeLogoButton(String pictureURL, String newpageURL, Applet applet, int w, int h) {
    super(w, h);
    setOwner(applet);
    gotoURL = newpageURL;
    setLogoURL(pictureURL);
  }
  public void setOwner(Applet applet) {
    owner = applet;
    this.addMouseListener(new MouseAdapter() {
        public void mousePressed(MouseEvent e) {
            ReadHTML r = new ReadHTML(gotoURL, owner);
        }
    });
  }

  public void setLogoURL(String pictureURL) {
    imageURL = pictureURL;
    try {
      logoImage = owner.getImage(new URL(owner.getDocumentBase(), pictureURL));
    } catch (Exception e) {
      return;
    }
    if (logoImage==null) {
      return;
    }
    MediaTracker waiter = new MediaTracker(this);
    Dimension pref = getPreferredSize();
    waiter.addImage(logoImage, 1, pref.width, pref.height);
    try {
      waiter.waitForAll();
    } catch (InterruptedException e) {return;}
    if (waiter.isErrorAny()) {
      return;
    }
  }

  // put logoImage onscreen
  public void paint(Graphics g) {
    Dimension pref = getPreferredSize();
    g.drawImage(logoImage, 0, 0, pref.width, pref.height, this);
    if ((gotoURL != null) && (!gotoURL.equals(""))) {
      g.setColor(Color.black);
      g.drawRect(0,0,pref.width-1,pref.height-1);
    }
  }
}
