//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator

/** 990722: lifted from Indeco as intended, to drive Gecko as an application. */

package gecko;

import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class GeckoMain {
	private static String protocolFile; // no default
	private static boolean batchFlag = false; // run graphics until told not to
	private static boolean restartFlag = false;
	private static int restartRun = 0;
	private static int restartTime = 0;

	/** Arguments:
	 *  none : take defaults
	 *  one  : protocol-filename (on local system)
	 *  two  : -b[atch] (run in batch mode, no windows)
	 */
	static public void processArguments(String[] args) {
		String syntax = "Syntax: java.exe -classpath huh gecko.GeckoMain [-batch] [-restart t runN] protocolpath";
		if (args.length == 0) {
			System.err.println("WARNING:  no protocol specified, using default basic3 scenario...");
			System.err.println(syntax);
			return;
		}
		for (int i=0; i<args.length; i++) {
			if ( (args[i].equalsIgnoreCase("-b")) || (args[i].equalsIgnoreCase("-batch")) )
				batchFlag = true;
			else if ( (args[i].equalsIgnoreCase("-r")) || (args[i].equalsIgnoreCase("-restart")) ) {
				restartFlag = true;
				i++;
				if (i == args.length) {
					Globals.log("Error: " + syntax);
					System.exit(1); // what should this integer be....
				}
				restartTime = Integer.parseInt(args[i]);
				i++;
				if (i == args.length) {
					Globals.log("Error: " + syntax);
					System.exit(1); // what should this integer be....
				}
				restartRun = Integer.parseInt(args[i]);
			}
			if (i == args.length-1)
				protocolFile = new String(args[i]);
		}
	}

	public static void main(String[] args) {
		processArguments(args);
		GeckoApplication runControl = new GeckoApplication(batchFlag, restartFlag, restartTime, restartRun, protocolFile);
		runControl.start();
	}
}
