//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator


package gecko;

public class Move {
  public double x; // direction x
  public double y; // direction y

  /** if make it this way, get a unit vector in x and y. */
  public Move(double angle) {
    x = Math.cos(angle);
    y = Math.sin(angle);
  }

  public Move(double finalx, double finaly) {
    x = finalx;
    y = finaly;
  }
  public Move(double distance, double unitx, double unity) {
    x = Math.abs(distance) * unitx;
    y = Math.abs(distance) * unity;
  }

  public void multByDistance(double distance) {
    x *= distance;
    y *= distance;
  }

  public String toString() {
    return "Move[x=" + x + ",y=" + y + "]";
  }
}
