//Title:        BacSim/Gecko
//Version:
//Copyright:    Copyright (c) 1997-2001, Jan Kreft, All rights reserved
//Author:       Jan Kreft, Kreft@cardiff.ac.uk
//Company:      University of Cardiff
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Bacterial Ecology Simulator (BacSim)
/**
 * 010114, move these out of Bacillus so instances take up less space. They
 * vary on a per-species aot per-individual basis. This is just a record,
 * not a class with behavior. Package-level visibility here, private where
 * instantiated in Bacillus.
 */

package gecko.bacsim;

public class BacillusParam {

  // defining params set by the protocol file bacillus
  // these are set BY Bacillus
  int process; // identifier for process, one species carries out one process
  int sub1;    // identifier for type of substrate
  int sub2;
  double y1, y2;
  double km1, km2, ki1;
  double maintenanceR;
  int eps; // do we have eps production? see types
  double epsProdCoeff, epsProdConst, epsDensity;

  // different--this says whether km1, etc. have been "converted to neutral
  // form", ie., whether Bacillus.grandmaInitChecks needs to massage them.
  boolean convertedFlag = false;

  public BacillusParam() {
    convertedFlag = false; // set true by grandmaInitChecks when converted.
  }
} 