//Title:        Gecko
//Version:
//Copyright:    Copyright (c) 1999, All rights reserved
//Author:       Ginger Booth, gingerbooth@cyber-wizard.com, ginger@gbooth.com
//Company:      Yale IBS/CCE
//Description:  Individual-Based Ecology Simulator
/**
 * 990930, vfb, original Java
 * Extends DefaultStageObserver to interpret "Adult" as anything that's
 * over "adultTime", as well as those who have reproduced for whatever reason.
 * Still stages newborn, juvie, adult.
 */
package gecko.statglue;
import gecko.zoo.*;

public class TLStageObserver extends DefaultStageObserver {

  /** Want stunted adults to show as stage adult. Super's version checks
   *  firstbornon and wantsToReproduce, neither true for stunted adults. */
  public int getStage(StageObservable agent) {
    if (!(agent instanceof TimeLimited))
      return 0;

    TimeLimited tl = (TimeLimited) agent;
    int answer = super.getStage(agent);
    // super considers juvenile
    if (answer == 1)
      if (tl.getAge() >= tl.getAdultTime())
        answer = 2;
    return answer;
  }


}