
//Title:        Indeco Steel Simulator
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Joseph Guse & Ginger Booth
//Company:      Yale FES/CCE
//Description:  Individual-based economic simulator
//of the steel industry, ore->consumer,
//with transportation.

/** Simply a MetaPlot/Vector of StatDumpers record.*/

/** Adopted from Indeco for Gecko-in-CourseWare, 990708, vfb. */

package stats;

import java.util.Vector;

public class MetaSink {
  private MetaPlot metaPlot;
  private Vector statDumpers; // of StatDumper

  public MetaSink(MetaPlot metaPlot) {
    this.metaPlot = metaPlot;
    statDumpers = new Vector(1,1);
  }

  public MetaPlot getMetaPlot() { return metaPlot;}
  public void addStatDumper(StatDumper statDumper) {
    if (hasStatDumper(statDumper))
      return;
    statDumpers.addElement(statDumper);
  }
  public boolean hasStatDumper(StatDumper statDumper) {
    return statDumpers.indexOf(statDumper) > -1;
  }
  public boolean hasStatDumper(Class anyMember) {
    for (int i=0; i<statDumpers.size(); i++)
      if (anyMember.isInstance( statDumpers.elementAt(i) ) )
        return true;
    return false;
  }
  public void removeStatDumper(StatDumper statDumper) {
    statDumpers.removeElement(statDumper);
  }
  public Vector getStatDumpers() { return statDumpers;}

  public void refresh() {
    for (int i=0; i<statDumpers.size(); i++)
      metaPlot.showOn((StatDumper)statDumpers.elementAt(i));
  }
}
