
//Title:        Indeco Steel Simulator
//Version:      
//Copyright:    Copyright (c) 1999
//Author:       Joseph Guse & Ginger Booth
//Company:      Yale FES/CCE
//Description:  Individual-based economic simulator
//of the steel industry, ore->consumer,
//with transportation.

/** In general, want statistics to go to plot, or file, or system.err, or....
 *  StatDumper is the common interface of that which PlotTrace's can added
 *  and dumped to.
 */

/** Adopted from Indeco for Gecko-in-CourseWare, 990708, vfb. */

package stats;


public interface StatDumper {
  public int addTrace(SumTrace readyTrace);
  public void removeTrace(SumTrace readyTrace);
  public void step();
  /** Update doesn't need to do anything. It's called when new traces are
   *  added to a StatDumper that's already in progress. Plotter does a
   *  repaint.
   */
  public void update();
  /** Clear is called between runs. Should get rid of all traces. */
  public void clear();
  /** Likewise, finalize needn't do anything. But it's available to get rid
   *  of graphics buffer allocation, close output files, whatever.
   */
  public void finalize();
}

