
//Title:        CourseWare stats package
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Ginger Booth
//Company:      CourseWare/CCE/YIBS
//Description:  CourseWare/Gecko/Indeco stats machinery

/** Any "agent" that the stats package is used to track, should descend
 *  from this limited proto-Agent. Its job is to notify interested parties
 *  when the Agent dies.
 *  Changed concept of "Agent" to "StatSource", since Gecko's stat sources
 *  will be species instead of individuals.
 */

package stats;

import java.util.Vector;

public class StatSource extends Object implements Cloneable {
  private static Vector statSourceDeathListenerList = new Vector();

  public static synchronized void addStatSourceDeathListener(StatSourceDeathListener adl) {
    statSourceDeathListenerList.addElement(adl);
  }
  public static synchronized void removeStatSourceDeathListener(StatSourceDeathListener adl) {
    statSourceDeathListenerList.removeElement(adl);
  }
  public static void notifyDeathListeners(StatSource a) {
    StatSourceDeathEvent event = new StatSourceDeathEvent(a);
    for (int i=0; i< statSourceDeathListenerList.size(); i++)
      ((StatSourceDeathListener) statSourceDeathListenerList.elementAt(i)).onDeath(event);
  }
}
