
//Title:        Indeco Steel Simulator
//Version:      
//Copyright:    Copyright (c) 1999
//Author:       Joseph Guse & Ginger Booth
//Company:      Yale FES/CCE
//Description:  Individual-based economic simulator
//of the steel industry, ore->consumer,
//with transportation.

/** Basic Agent stat broker. Just fill in getValue and getWeight.
 */
/** Adopted from Indeco AgentBirthEvent for Gecko-in-CourseWare, 990708, vfb.
 *  Changed concept of "Agent" to "StatSource", since Gecko's stat sources
 *  will be species instead of individuals.
 */

package stats;

import java.util.Vector;

abstract public class StatSourceBroker implements StatBrokerable {
  protected StatSource statsource;
  protected double normalizer = 1.0;
  protected boolean weighted = false;

  public StatSourceBroker() {}
  public StatSourceBroker(StatSource a) {statsource = a;}
  public StatSourceBroker(StatSource a, double normFactor, boolean weighted) {
    statsource = a;
    normalizer = normFactor;
    this.weighted = weighted;
  }
  public double getNormalizer() {return normalizer;}
  public void setNormalizer(double d) {normalizer = d;}
  /** True if want to weight the plot, not useful for SumTrace, is for AvgTrace (not yet) */
  public void setWeighted(boolean b) { weighted = b;}

  abstract public double getValue();
  abstract public double getWeight();
  public Object getStatSource() { return statsource; }
  public void setStatSource(Object statsource) { this.statsource = (StatSource) statsource; }
}

